(* file: bestcandidate.ml
 * author: Bob Muller
 * date: February 9, 2015
 *
 * Simple randomly distributed dots representing photoreceptor cells.
 *
 * depends: Asai/Uehara Universe Library
 * compile: ./make
 * run: ./bestcandidate
*)
open Color
open Image
open World
open Cs1101

(* constants *)

let displayWidth  = 800.                (* window width *)
let displayHeight = 600.                (* window height *)

(* type of world -- suggested
 *)
type point = {x:float; y:float; color:Color.t}
type world = {n:int; points:point list}

(* Helpers *******************************************************)

let empty = empty_scene displayWidth displayHeight

(* randomRGB produces red, green or blue with the likelihood of human
   photoreceptor cells.
 *)
let randomRGB () =
  let r = Random.float 1.0 in
  match r < 0.64 with
  | true  -> red
  | false -> match r < 0.98 with
	     | true  -> green
	     | false -> blue

let pointDiameter = 10.
let pointRadius = pointDiameter /. 2.

(* YOUR CODE HERE *)

let draw _ = failwith "draw is unimplemented"
let changeWorldOnTick _ = failwith "changeWorldOnTick is unimplemented"
let finished _ = failwith "finished is unimplemented"

let testPoints () =
  let n = Random.int 800
  in
  big_bang {n=n; points=[]}
           ~name:"Random Points"
           ~to_draw:draw
           ~on_tick:changeWorldOnTick
           ~width:(Cs1101.f2I displayWidth)
           ~height:(Cs1101.f2I displayHeight)
           ~rate:0.05
           ~stop_when:finished
           ~to_draw_last:draw

let _ = testPoints ()
